#include <zephyr.h>
#include <nrfx_timer.h>

#define TIMEOUT 1000

nrfx_timer_t my_timer = NRFX_TIMER_INSTANCE(0);
nrfx_timer_config_t my_timer_config = NRFX_TIMER_DEFAULT_CONFIG;

void timer_cb(nrf_timer_event_t event_type, void * p_context) {
    printk("foo\n");
}

void main() {
    printk("Timer sample started\n");

    IRQ_CONNECT(DT_NORDIC_NRF_TIMER_TIMER_0_IRQ_0, 
                DT_NORDIC_NRF_TIMER_TIMER_0_IRQ_0_PRIORITY, 
                nrfx_isr, 
                nrfx_timer_0_irq_handler, 
                0);


    my_timer_config.frequency = NRF_TIMER_FREQ_31250Hz;
    
    nrfx_err_t err = nrfx_timer_init(&my_timer, &my_timer_config, timer_cb);
    if (err != NRFX_SUCCESS) {
        printk("timer_init error: %d\n", err);
        return;
    }


    // Set the timer to trigger every second.
    printk("Setting compare, timeout after %d ticks\n", nrfx_timer_ms_to_ticks(&my_timer, TIMEOUT));
    nrfx_timer_compare(&my_timer, NRF_TIMER_CC_CHANNEL0, nrfx_timer_ms_to_ticks(&my_timer, TIMEOUT), true);
    
    printk("Starting timer\n");
    nrfx_timer_enable(&my_timer);
    
    printk("Timer started\n");
    
    while(1) {
        k_sleep(1000);
    }
}